## orp 1.0.9

=== Makefile ===
MAKEFILE = Makefile

.PHONY: all dbg opt clean

all: dbg opt

dbg: 
	cd mains/orp; $(MAKE) -f $(MAKEFILE) dbg;

opt: 
	cd mains/orp; $(MAKE) -f $(MAKEFILE) opt;

clean:
	cd mains/orp; $(MAKE) -f $(MAKEFILE) clean;

=== jar_zip_utils/Makefile ===
top_srcdir = ..

SOURCES = adler32.cpp \
crc32.cpp \
infblock.cpp \
infcodes.cpp \
inffast.cpp \
inflate.cpp \
inftrees.cpp \
infutil.cpp \
zutil.cpp \
Jar_Entry.cpp \
JarFile.cpp \
Manifest.cpp

INCLUDES = -I$(top_srcdir)/common/include

include $(top_srcdir)/mains/orp/MakeInclude

=== base_natives/common_olv2/Makefile ===
top_srcdir = ../..

INCLUDES = -I$(top_srcdir)/base_natives/common \
 -I$(top_srcdir)/os/$(UNAME)/include -I$(top_srcdir)/common/include \
 -I$(top_srcdir)/interface -I$(top_srcdir)/base_natives/common \
 -I$(top_srcdir)/arch/ia32/base_natives

SOURCES = mon_enter_exit.cpp thread_manager.cpp thread_generic.cpp \
 object_manager.cpp object_generic.cpp find_natives.cpp

include $(top_srcdir)/mains/orp/MakeInclude

=== base_natives/gnu_classpath/Makefile ===
top_srcdir = ../..

INCLUDES = -I$(top_srcdir)/base_natives/gnu_classpath \
 -I$(top_srcdir)/base_natives/gnu_classpath/include \
 -I$(top_srcdir)/os/$(UNAME)/include \
 -I$(top_srcdir)/common/include -I$(top_srcdir)/interface \
 -I$(top_srcdir)/base_natives/common \
 -I$(top_srcdir)/base_natives/common_olv2 \
 -I$(top_srcdir)/arch/ia32/base_natives

SOURCES = java_util_TimeZone.cpp java_util_ResourceBundle.cpp	\
 java_util_GregorianCalendar.cpp java_util_Date.cpp			\
 java_lang_VMSystem.cpp java_lang_VMSecurityManager.cpp			\
 java_lang_VMClassLoader.cpp java_lang_ThreadGroup.cpp			\
 java_lang_Thread.cpp java_lang_System.cpp java_lang_StringBuffer.cpp	\
 java_lang_Runtime.cpp java_lang_reflect_Field.cpp			\
 java_lang_reflect_Constructor.cpp java_lang_Object.cpp			\
 java_lang_Math.cpp java_lang_Float.cpp java_lang_Double.cpp		\
 java_lang_Class.cpp java_io_RandomAccessFile.cpp			\
 java_io_FileOutputStream.cpp java_io_FileInputStream.cpp		\
 java_io_FileDescriptor.cpp java_io_File.cpp initialization.cpp		\
 gnu_specific.cpp gnu_classpath_jni_utils.cpp find_natives_array.cpp	\
 java_net_InetAddress.cpp java_net_PlainSocketImpl.cpp			\
 java_net_PlainSocketImpl_common.cpp					\
 java_net_PlainDatagramSocketImpl.cpp					\
 java_lang_reflect_Array.cpp java_lang_reflect_Method.cpp		\
 java_io_ObjectInputStream.cpp java_io_ObjectOutputStream.cpp   \
 java_lang_PlatformProcess.cpp   \
 java_lang_Throwable.cpp

include $(top_srcdir)/mains/orp/MakeInclude

=== common/base/Makefile ===
top_srcdir = ../..

SOURCES = bytereader.cpp C_Interface.cpp compile.cpp exceptions.cpp	\
ini.cpp finalize.cpp jit_runtime_support.cpp jni.cpp jni_array.cpp	\
jni_field.cpp jni_method.cpp jni_utils.cpp orp.cpp orp_cout.cpp		\
orp_init.cpp orp_stats.cpp lock_manager.cpp		\
mem_alloc.cpp method.cpp method_lookup.cpp root_set_enum.cpp		\
stack_manipulation.cpp


INCLUDES = -I$(top_srcdir)/common/base -I$(top_srcdir)/os/$(UNAME)/include \
 -I$(top_srcdir)/common/include -I$(top_srcdir)/common/jit_utils/include\
 -I$(top_srcdir)/interface -I$(top_srcdir)/base_natives/common_olv2 \
 -I$(top_srcdir)/base_natives/common \
 -I$(top_srcdir)/arch/ia32/ia32_o1_jit -I$(top_srcdir)/arch/ia32/dump

include $(top_srcdir)/mains/orp/MakeInclude

=== common/class_loader/Makefile ===
CPP_EXTRAS = -D_POSIX_SOURCE -DZIP_JAR_ARCHIVE
top_srcdir = ../..
UNAME=$(shell uname -s)

INCLUDES = -I$(top_srcdir)/common/class_loader \
  -I$(top_srcdir)/os/$(UNAME)/include \
 -I$(top_srcdir)/common/include	\
 -I$(top_srcdir)/interface -I$(top_srcdir)/base_natives/common_olv2 \
 -I$(top_srcdir)/base_natives/common

SOURCES=Arena.cpp Class.cpp Class_File_Loader.cpp Class_Loader.cpp\
 Environment.cpp Mem_Manager.cpp Package.cpp Prepare.cpp Resolve.cpp\
 Signature.cpp String_Pool.cpp Verifier.cpp

include $(top_srcdir)/mains/orp/MakeInclude

=== common/gc/Makefile ===
CPP_EXTRAS = -DGC_DEBUG -DGC_GEN_V3
top_srcdir = ../..

INCLUDES = -I$(top_srcdir)/common/gc/include \
 -I$(top_srcdir)/os/$(UNAME)/include \
 -I$(top_srcdir)/common/include -I$(top_srcdir)/interface \
 -I$(top_srcdir)/base_natives/common

SOURCES = block_list.cpp block_store.cpp car.cpp card_table.cpp	\
 descendents.cpp exit.cpp garbage_collector.cpp gc_asserts.cpp		\
 gc_component.cpp gc_debug.cpp gc_for_orp.cpp gc_globals.cpp		\
 gc_header.cpp gc_hooks.cpp gc_interface.cpp gc_perf.cpp gc_plan.cpp	\
 gc_space.cpp gc_walk.cpp generation.cpp hash_table.cpp			\
 orp_interface.cpp los.cpp los_container.cpp mrl_gc_v1.cpp nursery.cpp	\
 nursery_step_gen.cpp object_list.cpp pair_table.cpp remembered_set.cpp	\
 sapphire.cpp slot_offset_list.cpp step.cpp step_generation.cpp		\
 train.cpp train_generation.cpp linux_api.cpp

include $(top_srcdir)/mains/orp/MakeInclude

=== common/gc_v2/Makefile ===
CPP_EXTRAS = -DGC_DEBUG -DGC_GEN_V3
top_srcdir = ../..

INCLUDES = -I$(top_srcdir)/common/gc_v2/include \
 -I$(top_srcdir)/os/$(UNAME)/include \
 -I$(top_srcdir)/common/include -I$(top_srcdir)/interface \
 -I$(top_srcdir)/base_natives/common

SOURCES = block_list.cpp block_store.cpp car.cpp card_table.cpp	cheney_fetcher.cpp \
 descendents.cpp exit.cpp garbage_collector.cpp gc_asserts.cpp		\
 gc_component.cpp gc_consts.cpp gc_debug.cpp gc_for_orp.cpp gc_globals.cpp \
 gc_header.cpp gc_hooks.cpp gc_interface.cpp gc_perf.cpp gc_plan.cpp	\
 gc_space.cpp gc_walk.cpp generation.cpp hash_table.cpp			\
 orp_interface.cpp los.cpp los_container.cpp mrl_gc_v1.cpp nursery.cpp	\
 nursery_step_gen.cpp object_list.cpp pair_table.cpp remembered_set.cpp	\
 sapphire.cpp slot_offset_list.cpp step.cpp step_generation.cpp		\
 train.cpp train_generation.cpp linux_api.cpp verify_heap.cpp

include $(top_srcdir)/mains/orp/MakeInclude

=== common/jit_utils/Makefile ===
top_srcdir = ../..

INCLUDES =  -I$(top_srcdir)/common/jit_utils \
 -I$(top_srcdir)/os/$(UNAME)/include \
 -I$(top_srcdir)/common/include \
 -I$(top_srcdir)/interface \
 -I$(top_srcdir)/base_natives/common -I$(top_srcdir)/common/jit_utils/include

SOURCES = Bit_Vector.cpp dump_jit.cpp jit_common.cpp mtable.cpp

include $(top_srcdir)/mains/orp/MakeInclude

=== mains/orp/Makefile ===
MAKEFILE = Makefile

UNAME=$(shell uname -s)
REDHAT_RELEASE = $(if $(wildcard /etc/redhat-release), -DREDHAT_RELEASE)
MAIN_DIR=$(shell pwd)
top_srcdir = ../..
BUILD_TARGET = orp

PLATFORM = $(top_srcdir)/os/$(UNAME)/platform_sticky_flag

CXX = g++
LINKER = g++
CC = gcc
IS_GCC = YES

NON_ORP_NATIVE_LIBS = #-DNON_ORP_NATIVE_LIBS
OLD_VERSION_CLASSPATH = #-DOLD_VERSION_CLASSPATH
LINUX_TLS_OPT = -DLINUX_TLS_OPT
ZIP_JAR_ARCHIVE = -DZIP_JAR_ARCHIVE 
USE_SEGMENT = #-DUSE_SEGMENT #see os/$(UNAME)/include/platform.h for TSD detail
MONITOR_STO = #-DMONITOR_STO
OLV2 = -DOBJECT_LOCK_V2
LAZY_LOCK = -DLAZY_LOCK
CONCURRENCY_ANALYSIS = #-DCONCURRENCY_ANALYSIS

GC = V2	 #use GC=V1 or GC=V2 to overide it for `make'
ifeq ($(GC), V1)
    GC_MODULE = gc
else
    GC_OPTIONS = -DGC_REWORK
    GC_MODULE = gc_v2
endif


CPP_DEFINES = -DORP_POSIX -D_REENTRANT -D__SMP__ \
	$(OLV2)	$(LAZY_LOCK)\
	$(CONCURRENCY_ANALYSIS) \
	$(ZIP_JAR_ARCHIVE) \
	$(REDHAT_RELEASE) \
	$(LINUX_TLS_OPT) $(USE_SEGMENT) \
	$(MONITOR_STO) \
	$(OLD_VERSION_CLASSPATH) \
	$(GC_OPTIONS) \
    $(NON_ORP_NATIVE_LIBS)

CPPFLAGS =  $(CPP_DEFINES) $(INCLUDES)


CXXFLAGS = 
DBG_CPPFLAGS = -D_DEBUG -DORP_STATS -DSIGNAL_DEBUG
DBG_CXXFLAGS = -g -O0
OPT_CPPFLAGS = -DNDEBUG
OPT_CXXFLAGS = -O 

INCLUDES = -I$(top_srcdir)/mains/orp \
 -I$(top_srcdir)/os/$(UNAME)/include \
 -I$(top_srcdir)/common/include \
 -I$(top_srcdir)/interface \
 -I$(top_srcdir)/base_natives/common \
 -I$(top_srcdir)/base_natives/common_olv2 \
 -I$(top_srcdir)/arch/ia32/ia32_o1_jit \
 -I$(top_srcdir)/arch/ia32/ia32_o3_jit \
 -I$(top_srcdir)/arch/ia32/dump/include \
 -I$(top_srcdir)/arch/ia32/debugger/include


COMMON_BASE_DIR = $(top_srcdir)/common/base
JAR_ZIP_UTILS_DIR = $(top_srcdir)/jar_zip_utils
ARCH_IA32_BASE_DIR = $(top_srcdir)/arch/ia32/base
ARCH_IA32_BASE_NATIVES_DIR = $(top_srcdir)/arch/ia32/base_natives
ARCH_IA32_O1_JIT_DIR = $(top_srcdir)/arch/ia32/ia32_o1_jit
ARCH_IA32_O3_JIT_DIR = $(top_srcdir)/arch/ia32/ia32_o3_jit
ARCH_IA32_X86_DIR = $(top_srcdir)/arch/ia32/x86
ARCH_IA32_DUMP_DIR = $(top_srcdir)/arch/ia32/dump
ARCH_IA32_DEBUGGER_DIR = $(top_srcdir)/arch/ia32/debugger
COMMON_JIT_UTILS_DIR = $(top_srcdir)/common/jit_utils
COMMON_CLASS_LOADER_DIR = $(top_srcdir)/common/class_loader
COMMON_GC_DIR = $(top_srcdir)/common/$(GC_MODULE)
BASE_NATIVES_COMMON_DIR = $(top_srcdir)/base_natives/common
BASE_NATIVES_COMMON_OLV2_DIR = $(top_srcdir)/base_natives/common_olv2
BASE_NATIVES_GNU_DIR = $(top_srcdir)/base_natives/gnu_classpath
OS_DIR = $(top_srcdir)/os/$(UNAME)

MODULES = \
 $(ARCH_IA32_O1_JIT_DIR) \
 $(ARCH_IA32_O3_JIT_DIR) \
 $(ARCH_IA32_DUMP_DIR) \
 $(ARCH_IA32_DEBUGGER_DIR) \
 $(COMMON_JIT_UTILS_DIR) \
 $(COMMON_CLASS_LOADER_DIR) \
 $(ARCH_IA32_BASE_DIR) \
 $(BASE_NATIVES_COMMON_DIR) \
 $(BASE_NATIVES_COMMON_OLV2_DIR) \
 $(ARCH_IA32_BASE_NATIVES_DIR) \
 $(COMMON_GC_DIR) \
 $(COMMON_BASE_DIR) \
 $(ARCH_IA32_X86_DIR) \
 $(BASE_NATIVES_GNU_DIR) \
 $(JAR_ZIP_UTILS_DIR) \
 $(OS_DIR) 

GENERIC_LIB_NAME = libvm.a
DBG_ARCHIVES := $(addsuffix /$(UNAME)/dbg/$(GENERIC_LIB_NAME), $(MODULES))
OPT_ARCHIVES := $(addsuffix /$(UNAME)/opt/$(GENERIC_LIB_NAME), $(MODULES))

ifeq ($(UNAME), FreeBSD)
  LINKER_FLAGS = -L/usr/local/lib -lpthread -lglib -lm -lgthread
else
  LINKER_FLAGS = -lglib -ldl -lm 
  ifdef USE_SEGMENT
    DBG_ARCHIVES := $(DBG_ARCHIVES) -lgthread
    OPT_ARCHIVES := $(OPT_ARCHIVES) -lgthread
  else
    DBG_ARCHIVES := $(DBG_ARCHIVES) /usr/lib/libpthread.a
    OPT_ARCHIVES := $(OPT_ARCHIVES) /usr/lib/libpthread.a
  endif
endif

LINKER_ENTRY =
LINKER_ARGS = $(LINKER_ENTRY) $(LINKER_FLAGS)



SOURCES = main.cpp stubs.cpp properties.cpp

DBGOBJ := $(SOURCES:%.cpp=$(UNAME)/dbg/%.o)
OPTOBJ := $(SOURCES:%.cpp=$(UNAME)/opt/%.o)
DBGDEP := $(SOURCES:%.cpp=$(UNAME)/dbg/dep/%.d)
OPTDEP := $(SOURCES:%.cpp=$(UNAME)/opt/dep/%.d)
DBG_READY_DEPS := $(wildcard $(DBGDEP))
OPT_READY_DEPS := $(wildcard $(OPTDEP))
DBG_MISSED_DEPS := $(filter-out $(DBG_READY_DEPS), $(DBGDEP))
OPT_MISSED_DEPS := $(filter-out $(OPT_READY_DEPS), $(OPTDEP))

BUILD_DBG_TARGET = $(UNAME)/dbg/$(BUILD_TARGET)
BUILD_OPT_TARGET = $(UNAME)/opt/$(BUILD_TARGET)

.PHONY: all opt dbg clean force platform
all:
	$(MAKE) dbg -f $(MAKEFILE)
	$(MAKE) opt -f $(MAKEFILE)

dbg: $(BUILD_DBG_TARGET)
opt: $(BUILD_OPT_TARGET)

%/$(UNAME)/dbg/$(GENERIC_LIB_NAME) : force
	@test -x $(@D) || mkdir -p $(@D)
	cd $(@D)/../.. ; $(MAKE) dbg -f $(MAKEFILE) 

%/$(UNAME)/opt/$(GENERIC_LIB_NAME) : force
	@test -x $(@D) || mkdir -p $(@D)
	cd $(@D)/../.. ; $(MAKE) opt -f $(MAKEFILE)

$(UNAME)/dbg/dep/%.d : %.cpp $(PLATFORM)
	@test -x $(UNAME)/dbg || mkdir -p $(UNAME)/dbg
	@test -x $(UNAME)/dbg/dep || mkdir -p $(UNAME)/dbg/dep
	!(test -e $@) || rm -f $@
	$(CXX) -MM $(CPPFLAGS) $(DBG_CPPFLAGS) $< \
	| sed 's|$*\.o[ :]*|$@ $(UNAME)/dbg/$*.o : |g' > $@

$(UNAME)/opt/dep/%.d : %.cpp $(PLATFORM)
	@test -x $(UNAME)/opt || mkdir -p $(UNAME)/opt
	@test -x $(UNAME)/opt/dep || mkdir -p $(UNAME)/opt/dep
	!(test -e $@) || rm -f $@
	$(CXX) -MM $(CPPFLAGS) $(OPT_CPPFLAGS) $< \
	| sed 's|$*\.o[ :]*|$@ $(UNAME)/opt/$*.o : |g' > $@

$(UNAME)/dbg/%.o : %.cpp $(PLATFORM)
	@test -x $(UNAME)/dbg || mkdir -p $(UNAME)/dbg
	$(CXX) -c $(CXXFLAGS) $(DBG_CXXFLAGS) $(DBG_CPPFLAGS) $(CPPFLAGS) $< -o $@

$(UNAME)/opt/%.o : %.cpp $(PLATFORM)
	@test -x $(UNAME)/opt || mkdir -p $(UNAME)/opt
	$(CXX) -c $(CXXFLAGS) $(OPT_CXXFLAGS) $(OPT_CPPFLAGS) $(CPPFLAGS) $< -o $@

$(BUILD_DBG_TARGET): $(DBG_MISSED_DEPS) $(DBG_ARCHIVES) $(DBGOBJ)
	@test -x $(UNAME)/dbg || mkdir -p $(UNAME)/dbg
	@test -x $(UNAME)/dbg/dep || mkdir -p $(UNAME)/dbg/dep
	$(LINKER) -o $(BUILD_DBG_TARGET) $(LINKER_ARGS) $(DBGOBJ) $(DBG_ARCHIVES)

$(BUILD_OPT_TARGET): $(OPT_MISSED_DEPS) $(OPT_ARCHIVES) $(OPTOBJ)
	@test -x $(UNAME)/opt || mkdir -p $(UNAME)/opt
	@test -x $(UNAME)/opt/dep || mkdir -p $(UNAME)/opt/dep
	$(LINKER) -o $(BUILD_OPT_TARGET) $(LINKER_ARGS) $(OPTOBJ) $(OPT_ARCHIVES) 

clean:
	@(!(test -e $(UNAME))&&(echo Already cleaned.)) || ( rm -fr $(UNAME); echo rm -rf $(UNAME))
	cd $(JAR_ZIP_UTILS_DIR);          $(MAKE) clean -f $(MAKEFILE)
	cd $(COMMON_BASE_DIR);            $(MAKE) clean -f $(MAKEFILE)
	cd $(ARCH_IA32_BASE_DIR);         $(MAKE) clean -f $(MAKEFILE)
	cd $(ARCH_IA32_BASE_NATIVES_DIR); $(MAKE) clean -f $(MAKEFILE)
	cd $(ARCH_IA32_DUMP_DIR);      	  $(MAKE) clean -f $(MAKEFILE)
	cd $(ARCH_IA32_DEBUGGER_DIR);     $(MAKE) clean -f $(MAKEFILE)
	cd $(ARCH_IA32_O1_JIT_DIR);       $(MAKE) clean -f $(MAKEFILE)
	cd $(ARCH_IA32_O3_JIT_DIR);       $(MAKE) clean -f $(MAKEFILE)
	cd $(ARCH_IA32_X86_DIR);          $(MAKE) clean -f $(MAKEFILE)
	cd $(COMMON_CLASS_LOADER_DIR);    $(MAKE) clean -f $(MAKEFILE)
	cd $(COMMON_GC_DIR);              $(MAKE) clean -f $(MAKEFILE)
	cd $(COMMON_JIT_UTILS_DIR);       $(MAKE) clean -f $(MAKEFILE)
	cd $(BASE_NATIVES_COMMON_DIR);    $(MAKE) clean -f $(MAKEFILE)
	cd $(BASE_NATIVES_COMMON_OLV2_DIR);$(MAKE) clean -f $(MAKEFILE)
	cd $(BASE_NATIVES_GNU_DIR);       $(MAKE) clean -f $(MAKEFILE)
	!(test -L $(OS_DIR)) || ( cd $(OS_DIR); $(MAKE) clean -f $(MAKEFILE))

ifeq ($(MAKECMDGOALS), dbg)
-include $(DBGDEP)
else
ifeq ($(MAKECMDGOALS), opt)
-include $(OPTDEP)
endif
endif

$(PLATFORM):
	if [ $(UNAME) = "Linux" ]; then \
		test -L $(top_srcdir)/os/Linux || ln -sfn linux $(top_srcdir)/os/Linux;\
        touch $(top_srcdir)/os/Linux/platform_sticky_flag; \
	elif echo $(UNAME) | grep -qi bsd; then \
		test -L $(top_srcdir)/os/$(UNAME) || ln -sfn bsd $(top_srcdir)/os/$(UNAME);\
        touch $(top_srcdir)/os/$(UNAME)/platform_sticky_flag; \
	fi

=== os/linux/Makefile ===
top_srcdir = ../..

INCLUDES = -I$(top_srcdir)/os/linux \
 -I$(top_srcdir)/os/linux/include -I$(top_srcdir)/common/include \
 -I$(top_srcdir)/interface -I$(top_srcdir)/base_natives/common \
 -I$(top_srcdir)/base_natives/common_olv2 \
 -I$(top_srcdir)/base_natives/gnu_classpath/include

SOURCES = os_wrapper.cpp platform_utils.cpp signals_ia32.cpp

include $(top_srcdir)/mains/orp/MakeInclude

=== arch/ia32/base/Makefile ===
top_srcdir = ../../..

INCLUDES = -I$(top_srcdir)/arch/ia32/base \
 -I$(top_srcdir)/os/$(UNAME)/include \
 -I$(top_srcdir)/common/include \
 -I$(top_srcdir)/common/jit_utils/include \
 -I$(top_srcdir)/interface -I$(top_srcdir)/base_natives/common_olv2 \
 -I$(top_srcdir)/base_natives/common \
 -I$(top_srcdir)/arch/ia32/ia32_o1_jit -I$(top_srcdir)/arch/ia32/dump \
 -I$(top_srcdir)/arch/ia32/debugger/include

SOURCES = compile_IA32.cpp \
 enum_trampoline.cpp exceptions_ia32.cpp ini_iA32.cpp	\
 jit_runtime_support_ia32.cpp root_set_enum_ia32.cpp	\
 jit_lock_rt_support_ia32.cpp 	\
 stack_manipulation_ia32.cpp

include $(top_srcdir)/mains/orp/MakeInclude

## orp 0.1

=== debian/changelog ===
orp (0.1) fremantle; urgency=low

  * Initial release

 -- Mohammad Abu-Garbeyyeh <mohammad7410@gmail.com>  Tue, 05 May 2010 02:53:59 +0400

=== debian/control ===
Source: orp
Section: user/games
Priority: extra
Maintainer: Mohammad Abu-Garbeyyeh <mohammad7410@gmail.com>
Build-Depends: debhelper (>= 5)
Standards-Version: 3.7.2

Package: orp
Architecture: armel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Application to control a PS3 via Remote Play
 *** THIS APPLICATION RUNS AT VERY LOW SPEEDS ON THE N900 ***
 Wouldn't it be cool if you could run Remote Play from your laptop, desktop, or
 perhaps your phone?
 .
 After 2 weeks of hardcore reverse-engineering, now you can!
 . 
 I would like to thank Dark_AleX for hacking the PSP.  Without his work, ORP
 would not be possible.  I would also like to thank TyRaNiD for psplink and
 prxtool.  Using psplink makes this type of work almost painless!  Thanks to
 jas0nuk for the essential PRXdecrypter utility.
 .
 Thanks to Greg of http://ps3-hacks.com for the MacBook loan and beer!
 .
 Thanks to MohammadAG for the virtual keyboard idea!
XB-Maemo-Display-Name: Open Remote Play
XB-Maemo-Icon-26:
 iVBORw0KGgoAAAANSUhEUgAAACAAAAAgCAYAAABzenr0AAAAAXNSR0IArs4c
 6QAAAAZiS0dEAP8A/wD/oL2nkwAAAAlwSFlzAAALEwAACxMBAJqcGAAAAAd0
 SU1FB9oFBBcmMbOauyUAABArSURBVFgJASAQ3+8BAAAA/wAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAACAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAADAAAAgAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAXFxcAj4+PADg4OAAJCQkA+Pj4APT09AD///8AAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAEAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAFBQUAOjo6ACoqKgD29vYA7u7uANHR0QC7u7sAwsLCANvb2wD19fUA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAA/wAAAP8AAAD/AAAA/wAAAP8AAAD/AAAA/wAAAP8AAAD/AAAA/wAAAP8c
 HBz/09PT///////////////////////9/f3/5ubm/7a2tv9aWlr/FRUV/wAA
 AP8AAAD/AAAA/wAAAP8AAAD/AAAA/wAAAP8AAAD/AAAA/wAAAP8AAAAA/wAA
 AP8AAAD/AAAA/wAAAP8AAAD/AAAA/wAAAP8AAAD/AAAA/wAAAP8cHBz/09PT
 ///////////////////////+/v7//f39///////7+/v/x8fH/0dHR/8CAgL/
 AAAA/wAAAP8AAAD/AAAA/wAAAP8AAAD/AAAA/wAAAP8AAAAA/wAAAP8AAAD/
 AAAA/wAAAP8AAAD/AAAA/wAAAP8AAAD/AAAA/wAAAP8cHBz/09PT////////
 //////////39/f+ampr/aWlp//Pz8/////////////r6+v9oaGj/BAQE/wAA
 AP8AAAD/AAAA/wAAAP8AAAD/AAAA/wAAAP8AAAAA/wAAAP8AAAD/AAAA/wAA
 AP8AAAD/AAAA/wAAAP8AAAD/AAAA/wAAAP8cHBz/09PT////////////////
 //X19f9NTU3/AwMD/8XFxf/////////////////r6+v/NTU1/wAAAP8AAAD/
 AAAA/wAAAP8AAAD/AAAA/wAAAP8CAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAP///wD+
 /v4A/f39APDw8AAAAAAAAAAAAAAAAAAUFBQAXV1dAAICAgAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAACAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA 
 AAEBAQAAAAAAAAAAAAAAAAAAAAAANzc3ABISEgAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAACAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAGBgYABUVFQAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAACAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAABwcHAAYGBgAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAA/f39AP39/QAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA 
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA7Ozs
 AO/v7wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAx8fHAOjo6AAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAEBAQAUFBQACAgIAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAPz8/AAAAAAAAAAAAAAAAADX19cAkJCQAP39/QAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAEAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAICAgAWFhYAMDAwAFFRUQA/Pz8AICAgAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAH5+fgDKysoAIiIiAOjo6ACjo6MA2traAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAEAAAAAAAAAAAAAAAAAAAAAAEBAQAKCgoALCwsAE1NTQBI
 SEgAKysrAAgICAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAwMDAN3d
 3QCtra0AJSUlAB8fHwBTU1MAAgICAPT09ADk5OQA2dnZAODg4AD19fUA/Pz8 
 AAAAAAAEAAAAAAAAAAACAgIAHx8fAE1NTQBSUlIAODg4AAcHBwAAAAAAAAAA
 AAAAAAD5+fkAAgICAAUFBQAAAAAAAAAAAAEBAQArKysAOjo6AEZGRgArKysA
 CQkJAAAAAAAAAAAAAAAAAAAAAAAAAAAA/Pz8ANbW1gC9vb0AqqqqAMjIyAAB
 AwMD/0RERABoaGgAQUFBAAwMDAADAwMAAAAAAAAAAAD09PQAy8vLALGxsQDO 
 zs4Al5eXACsrKwAAAAAAAAAAAAAAAAD8/PwAAwMDAAEBAQAAAAAAAAAAAPPz 
 8wDKysoAxMTEAOjo6AANDQ0AZ2dnACMjIwD///8A9fX1AJSUlAAAZWVl/+rq
 6v/////////////////29vb/0NDQ/4+Pj/84ODj/EBAQ/wYGBv83Nzf/29vb
 //////////////////////////////////Pz8//Ozs7/jIyM/zc3N/8QEBD/
 BwcH/yQkJP9eXl7/4eHh/////////////////+Hh4f8AsLCw//7+/v//////
 //////f39/9kZGT/ICAg/woKCv8TExP/SkpK/52dnf/a2tr//Pz8////////
 //////////7+/v/l5eX/m5ub/0tLS/8ZGRn/BQUF/xQUFP9OTk7/n5+f/9ra
 2v/7+/v////////////9/f3/6Ojo/2xsbP8ANjY2/9LS0v/+/v7///////z8
 /P+6urr/oKCg/6ysrP/W1tb//v7+////////////////////////////////
 //X19f9TU1P/AAAA/wQEBP80NDT/jY2N/9fX1///////////////////////
 /////+Xl5f+SkpL/MjIy/wAAAP8BAAAA/wwMDAA8PDwAR0dHADAwMAAfHx8A
 ERERAAcHBwAAAAAA+fn5AO/v7wDt7e0AJycnAA0NDQAAAAAAAAAAAPb29gB9
 fX0ABwcHAFVVVQAqKioABgYGAAEBAQAAAAAA////AOXl5QDCwsIAq6urAL6+
 vgD09PQA/v7+AAAAAAABAAAA/wAAAAAAAAAABAQEAAwMDAAMDAwACgoKAAkJ
 CQABAQEA9vb2APb29gAPDw8AqqqqACoqKgAAAAAAAAAAAP///wD09PQACgoK
 AAMDAwAAAAAA////AO3t7QDKysoAra2tAMHBwQDl5eUA+Pj4AAAAAAACAgIA
 FhYWAPv7+wABAAAA/wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAANDQ0AbGxsAFZWVgAgICAADQ0NAAMDAwAAAAAA////APPz8wDc
 3NwAtra2ALa2tgDR0dEA9vb2AAAAAAAAAAAAAAAAAAAAAAAXFxcAVFRUAPr6
 +gABAAAA/wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAoKCgAyMjIAREREAEhISAAaGhoAs7OzAK+vrwDKysoA8vLy
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAXFxcARkZGAAEBAQABAAAA
 /wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAsvjm+kU1q9QAAAABJRU5ErkJggg==
 ====

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1




CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.

	touch configure-stamp


build: build-stamp

build-stamp: configure-stamp
	dh_testdir
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# ======================================================
	mkdir -p "$(CURDIR)/debian/orp"
	cp -r $(CURDIR)/src/* "$(CURDIR)/debian/orp/opt/openremoteplay"
	cp -a "$(CURDIR)/openremoteplay.png" "$(CURDIR)/debian/orp/usr/share/pixmaps/"
	cp -a "$(CURDIR)/openremoteplay.desktop" "$(CURDIR)/debian/orp/usr/share/applications/hildon/"

	# ======================================================

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs debian/changelog
	dh_installdocs
	dh_installexamples
#	dh_install
#	dh_installmenu
#	dh_installdebconf
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_python
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
